const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const subjects = sequelize.define(
    'subjects',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

name_bn: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subjects.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



































    db.subjects.hasMany(db.study_groups, {
      as: 'study_groups_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });










//end loop



    db.subjects.belongsTo(db.subject_categories, {
      as: 'category',
      foreignKey: {
        name: 'categoryId',
      },
      constraints: false,
    });




    db.subjects.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subjects.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return subjects;
};


